#include <stdlib.h>

#include "AB.h"

extern "C" void exit(int); // <stdlib.h>

A::A() : _b(Association<A, B>(2, 4, 2, 4, "A-B")) {
}

B::B() : _a(Association<A, B>(2, 4, 2, 4, "A-B")) {
}

int main() {
    B b1, b2;
    try {
        A a;
        assert(a._b.add(a, b1));
        assert(!a._b.add(a, b1));
        assert(a._b.add(a, b2));
        assert(b1._a.test(a, b2));
    } catch (Role<B>::RoleException) {
        ::exit(1);
    } catch (Association<A, B>::AssociationException) {
        ::exit(1);
    }
    
    return 0;
}
