#ifndef _GDMO_pattern_reuse
#define _GDMO_pattern_reuse

#include "GDMO_pattern.h"

class SLTE : public Network_element {
};

class Geographical_site;

class SLTE_agent : public Agent {
public:
    static Association<Geographical_site, SLTE_agent> geographical_site;
    static Aggregation<SLTE_agent, SLTE> slte;
public:
    virtual Role<Manager> manager() const;
    virtual Composite<Network_element> managed_objects() const;
};

class Fault_location_manager;

class Geographical_site {
public:
    static Association<Fault_location_manager, Geographical_site> fault_location_manager;
    static Association<Geographical_site, SLTE_agent> slte_agent;
};

class Fault_location_manager : public Manager {
public:
    static Association<Fault_location_manager, Geographical_site> geographical_site;
public:
    virtual Role<Agent> agent() const;
    virtual Role<Network_element> accessed_objects() const;
};

#endif
