#include <iostream>

#include "GDMO_pattern_reuse.h"

int main(int argc, char** argv) {
    Fault_location_manager fault_location_manager;
    Geographical_site Alexandria, Cyprus, Marmaris, Creta, Mazara, Tetouan, Sesimbra;
    SLTE_agent slte_agent_Alexandria, slte_agent_Cyprus, slte_agent_Marmaris, slte_agent_Creta, slte_agent_Mazara, slte_agent_Tetouan, slte_agent_Sesimbra;
    SLTE slte_1, slte_2, slte_3, slte_4, slte_5, slte_6, slte_7, slte_8, slte_9, slte_10, slte_11, slte_12, slte_13, slte_14, slte_15, slte_16;

    Fault_location_manager::geographical_site.add(fault_location_manager, Alexandria);
    Fault_location_manager::geographical_site.add(fault_location_manager, Cyprus);
    Fault_location_manager::geographical_site.add(fault_location_manager, Marmaris);
    Fault_location_manager::geographical_site.add(fault_location_manager, Creta);
    Fault_location_manager::geographical_site.add(fault_location_manager, Mazara);
    Fault_location_manager::geographical_site.add(fault_location_manager, Tetouan);
    Fault_location_manager::geographical_site.add(fault_location_manager, Sesimbra);

    Geographical_site::slte_agent.add(Alexandria, slte_agent_Alexandria);
    Geographical_site::slte_agent.add(Cyprus, slte_agent_Cyprus);
    Geographical_site::slte_agent.add(Marmaris, slte_agent_Marmaris);
    Geographical_site::slte_agent.add(Creta, slte_agent_Creta);
    Geographical_site::slte_agent.add(Mazara, slte_agent_Mazara);
    Geographical_site::slte_agent.add(Tetouan, slte_agent_Tetouan);
    Geographical_site::slte_agent.add(Sesimbra, slte_agent_Sesimbra);

    SLTE_agent::slte.add(slte_agent_Alexandria, slte_1);
    SLTE_agent::slte.add(slte_agent_Alexandria, slte_2);
    SLTE_agent::slte.add(slte_agent_Cyprus, slte_3);
    SLTE_agent::slte.add(slte_agent_Cyprus, slte_4);
    SLTE_agent::slte.add(slte_agent_Marmaris, slte_5);
    SLTE_agent::slte.add(slte_agent_Marmaris, slte_6);
    SLTE_agent::slte.add(slte_agent_Creta, slte_7);
    SLTE_agent::slte.add(slte_agent_Creta, slte_8);
    SLTE_agent::slte.add(slte_agent_Mazara, slte_9);
    SLTE_agent::slte.add(slte_agent_Mazara, slte_10);
    SLTE_agent::slte.add(slte_agent_Mazara, slte_11);
    SLTE_agent::slte.add(slte_agent_Mazara, slte_12);
    SLTE_agent::slte.add(slte_agent_Tetouan, slte_13);
    SLTE_agent::slte.add(slte_agent_Tetouan, slte_14);
    SLTE_agent::slte.add(slte_agent_Sesimbra, slte_15);
    SLTE_agent::slte.add(slte_agent_Sesimbra, slte_16);

    std::cout << "Number of accessed objects: " << (fault_location_manager.accessed_objects()).size();

    return 0;
}
